var gsio_tree_view;
var gMyAddr=new Object;
var gHeaderParser = Components.classes["@mozilla.org/messenger/headerparser;1"].
        getService(Components.interfaces.nsIMsgHeaderParser);
var gPrefs = Components.classes["@mozilla.org/preferences-service;1"].
        getService(Components.interfaces.nsIPrefBranch);
var gMessenger = Components.classes['@mozilla.org/messenger;1'].createInstance().
    QueryInterface(Components.interfaces.nsIMessenger);
var gAserv=Components.classes["@mozilla.org/atom-service;1"].
          getService(Components.interfaces.nsIAtomService);

var sioData = new Object;
var sioAddr = new Object;

var gPrefixType;
var gInTextPrefix='';
var gOutTextPrefix='';

var sio_folderListener = {
  OnItemEvent: function(item, event) { // ( nsIMsgFolder item , nsIAtom event )
//dump(item.name+' '+event+'\n');
//z.B. 'FolderLoaded', 'DeleteOrMoveMsgCompleted', 'CompactCompleted'
    if (event=='CompactCompleted') {
      // clear cache!
      delete sioData;
      delete sioAddr;
      sioData = new Object;
      sioAddr = new Object;
//dump('SIO: cache cleared\n');
    }
  }
}


function sio_init() {

  //see http://developer.mozilla.org/en/docs/Extensions:Thunderbird:Creating_a_Custom_Column
  // this is a noop (since "MsgCreateDBView" is not available),
  // if the custom column mechanism is not available (as in TB<2.0)
  var ObserverService = Components.classes["@mozilla.org/observer-service;1"].
    getService(Components.interfaces.nsIObserverService);
  ObserverService.addObserver(sio_CreateDbObserver, "MsgCreateDBView", false);


/*
 *  Install Listener
 */
  var session=
    Components.classes["@mozilla.org/messenger/services/session;1"].
      getService(Components.interfaces.nsIMsgMailSession);
  session.AddFolderListener(sio_folderListener, 128); //folderListenerNotifyFlagValue  	 event

/*
 *  Find all email addresses, which count as mine
 */
  var accountMgr=
    Components.classes["@mozilla.org/messenger/account-manager;1"].
      getService(Components.interfaces.nsIMsgAccountManager);
  var allAccounts=accountMgr.accounts;
  var accountsCount = allAccounts.Count();
  for (var i = 0; i < accountsCount; i++) {
    var account = allAccounts.QueryElementAt(i, Components.interfaces.nsIMsgAccount);
    var allIdentities=account.identities;
    var identitiesCount = allIdentities.Count();
    for (var j = 0; j < identitiesCount; j++) {
      var identity = allIdentities.QueryElementAt(j, Components.interfaces.nsIMsgIdentity);
      if (identity.email) { //see mail from "Simon Arthur"
        var email=identity.email.toLowerCase();
        if (gMyAddr[email]===undefined)
          gMyAddr[email]=1;
//dump(identity.email+'\n');
      }
    }
  }

  try { gPrefixType = gPrefs.getCharPref("extensions.showInOut.PrefixType"); } catch(e) { gPrefixType='none'; }
  if (gPrefixType=='text') {
    try { gInTextPrefix = gPrefs.getCharPref("extensions.showInOut.InTextPrefix"); } catch(e) { gInTextPrefix=''; }
    try { gOutTextPrefix = gPrefs.getCharPref("extensions.showInOut.OutTextPrefix"); } catch(e) { gOutTextPrefix=''; }
  }

}

function sio_extractName(email, isJunk) {
  var addrs={};
  var names={};
  var full={};
  var count=0;
  count=gHeaderParser.parseHeadersWithArray( email, addrs, names, full, count);
  var show='';
  for (var i=0; i<count; i++) {
    if (isJunk)
      s=full.value[i];
    else {
      s=names.value[i];
      if (!s) s=addrs.value[i];
      if (s.indexOf(',')>=0 && s.charAt(0)!='"'&& s.charAt(0)!="'") s='"'+s+'"';
    }
    if (show) show+=', ';
    show+=s;
  }
  return show;
}

function sio_getMsgInfo(messageURI, msgHdr) {
//dump('sio_getMsgInfo: '+messageURI+'\n');
  if (!msgHdr)
    msgHdr=gMessenger.msgHdrFromURI(messageURI);
  // extract just the mail address from the author and compare to the list of 'my' Addresses
  var author = gHeaderParser.extractHeaderAddressMailboxes(null, msgHdr.author).toLowerCase();
  var received=gMyAddr[author]===undefined?'in':'out';

  sioData[messageURI]=received;

  var junkScore = msgHdr.getStringProperty("junkscore");
  // according to SelectedMessagesAreJunk() in mailWindowOverlay.js:
  var isJunk =  ((junkScore != "") && (junkScore != "0"));
  // but i think its:
  //var isJunk =  ((junkScore === "") || (junkScore != "0"));
  sioAddr[messageURI] = received=='in' ?
      gInTextPrefix+sio_extractName(msgHdr.mime2DecodedAuthor, isJunk)  :
      gOutTextPrefix+sio_extractName(msgHdr.mime2DecodedRecipients, false) ;
}

//------------------------------------------------------------------------------------

/*  from mailnews/base/public/nsIMsgCustomColumnHandler.idl
       When implementing a js custom column handler (of type nsITreeView) you must implement the following
       functions:
       1. isEditable
       2. GetCellProperties
       3. GetImageSrc
       4. GetCellText
       5. CycleCell
       6. GetSortStringForRow
       7. GetSortLongForRow
       8. isString
       
       You can, at your option, implement (No, you must! (gg))
       9.  GetRowProperties.
    (also see mailnews/base/src/nsMsgDBView.cpp)

  GetRowProperties is called for columns, which are not visible, but
  GetCellProperties is called only for visible columns!
*/

//--------------------------------------
var sio_columnHandler_inoutcol = {
  getCellText:         function(row, col) {
  },
  getCellProperties:   function(row, col, properties) {
//dump('Get cel inoutcol\n');
      var messageURI = gDBView.getURIForViewIndex(row);
      if (sioData[messageURI] === undefined) {
        sio_getMsgInfo(messageURI, hdr);
      }
      var received=sioData[messageURI];
        //properties already defined:
        //    focus, [leaf|container], [even|odd], sio_inoutCol
        //  appending [in|out]
      if (received!==null) {
        properties.AppendElement(gAserv.getAtom(received));
      }
  },
  getRowProperties:    function(row, properties) {
    //this is done in the sio_inoutaddresscol
  },
  getImageSrc:         function(row, col) {
    return null;
  },

  //not really called !?
 	isEditable:          function(row, col) {
    return false;
  },
 	cycleCell:           function(row, col) {
  },

  getSortStringForRow: function(hdr) {
//dump('called sort strin in inoutcol\n');
    return '';
  },
  getSortLongForRow:   function(hdr) {
//dump('called sort long in inoutcol\n');
    var messageURI=hdr.folder.getUriForMsg(hdr);
    if (sioData[messageURI] === undefined) {
      sio_getMsgInfo(messageURI, hdr);
    }
    if (sioData[messageURI]=='in') return 0;
    else return 1;
  },
  isString:            function() {
    return false;
  }

}

//--------------------------------------
var sio_columnHandler_inoutaddresscol = {
  getCellText:         function(row, col) {
    var messageURI = gDBView.getURIForViewIndex(row);
    if (sioData[messageURI] === undefined)
      sio_getMsgInfo(messageURI);
//should probably use: FetchAuthor(msgHdr);
//should probably use: FetchRecipients(msgHdr);
//dump('Get cell inoutaddresscol row='+row+' URI= '+messageURI+' returned '+sioAddr[messageURI]+'\n');
    return sioAddr[messageURI];
  },
  getCellProperties:   function(row, col, properties) {
//dump('Get cel inoutaddresscol row='+row+'\n');
      var messageURI = gDBView.getURIForViewIndex(row);
      if (sioData[messageURI] === undefined) {
        sio_getMsgInfo(messageURI, hdr);
      }
      var received=sioData[messageURI];
        //properties already defined:
        //    focus, [leaf|container], [even|odd], sio_inoutCol
        //  appending [in|out]
      if (received!==null) {
        properties.AppendElement(gAserv.getAtom(received));
      }
  },
  getRowProperties:    function(row, properties) {
//dump('Get row inoutaddresscol index='+row+'\n');
    var messageURI = gDBView.getURIForViewIndex(row);
    if (sioData[messageURI] === undefined) {
      sio_getMsgInfo(messageURI);
    }
    var received=sioData[messageURI];
      //properties already defined:
      //    ???
      //  appending [in|out]
    if (received!==null) {
      properties.AppendElement(gAserv.getAtom(received));
/*
      //try to set this property an _all_ cells in the row!
      var cols=document.getElementById('threadTree').columns;
//dump(cols+'\n');
      var col=cols.getFirstColumn();
      while (col) {
//dump(col.id+'\n');
        var props = Components.classes["@mozilla.org/supports-array;1"].createInstance().
            QueryInterface(Components.interfaces.nsISupportsArray);
        gDBView.getCellProperties(row, col, props);
        props.AppendElement(gAserv.getAtom(received));
        col=col.getNext();
      }
*/
    }
  },
  getImageSrc:         function(row, col) {
/*
    if (col.id=='sio_inoutaddressCol') {
      // image inserted in front of the text, returned in getCellText
      return "chrome://showInOut/skin/out.png";
    }
*/
    return null;
  },

  //not really called !?
 	isEditable:          function(row, col) {
    return false;
  },
 	cycleCell:           function(row, col) {
  },

  getSortStringForRow: function(hdr) {
//dump('called sort string in inoutaddresscol\n');
    var messageURI=hdr.folder.getUriForMsg(hdr);
    if (sioData[messageURI] === undefined) {
      sio_getMsgInfo(messageURI, hdr);
    }
    var s=sioAddr[messageURI];
    if (s.substr(0,1)=='"') s=s.substr(1);
    return s;
  },
  getSortLongForRow:   function(hdr) {
//dump('called sort long in inoutaddresscol\n');
  },
  isString:            function() {
    return true;
  }

}

//------------------------------------------------------------------------------------

var sio_CreateDbObserver = {
  // Components.interfaces.nsIObserver
  observe: function(aMsgFolder, aTopic, aData)
  {
    gDBView.addColumnHandler("sio_inoutCol", sio_columnHandler_inoutcol);
    gDBView.addColumnHandler("sio_inoutaddressCol", sio_columnHandler_inoutaddresscol);
  }
}

// Call when the window is fully loaded, prevent racing condition
window.addEventListener("load", sio_init, false);
//setTimeout(sio_init, 1000);


function dumpTree() {
  var tree=document.getElementById('threadTree');
//  dump('DOM: '+tree.tagName+'\n');
  var rows=tree.firstChild.nextSibling; //treechildren, nicht xul:treerows!!!
  //rows.firstChild: ex. nicht!
  //rows.childNodes.length=0 !!!
}

function dumpProps(row, col, properties) {
  for (var i=0; i<properties.Count(); i++) {
    var prop;
    prop=properties.GetElementAt(i).QueryInterface(Components.interfaces.nsIAtom);
    dump('prop ('+row+','+col.id+'): '+prop.toString()+"\n");
  }
}

